
from __future__ import print_function
import numpy as np
from keras.preprocessing import sequence
from keras.models import Sequential, Model
from keras.layers import Dense, Dropout, Activation
from keras.layers import Embedding, Input, Merge, Flatten
from keras.layers import Convolution1D, GlobalMaxPooling1D, MaxPooling1D
from keras.datasets import imdb
from keras.preprocessing.text import *
from keras import backend as K
from keras.utils.np_utils import to_categorical
from keras.models import model_from_json
from keras.utils.visualize_util import plot
from keras.regularizers import l2, activity_l2
import os
from six.moves import cPickle
import jieba
from draw_data import draw_data
np.random.seed(1337)


from gensim.models.word2vec import Word2Vec
def word2vec1():
 file = open('sentence.txt')sss=[]
 while True:
     ss=file.readline().replace('\n','').rstrip()
     if ss=='':        break    s1=ss.split(" ")
     sss.append(s1)file.close()model = Word2Vec(size=200, workers=5)
     build_vocab(sss)model.train(sss,total_examples = model.corpus_count,epochs = model.iter)model.save('./data/gensim_w2v_sg0_model')
     new_model = gensim.models.Word2Vec.load('w2v_model')


def get_data(fold):
    dax = []
    day = []
    for fname in os.listdir(fold):
        fpath = os.path.join(fold, fname)
        split_file_path = os.path.join(fold, fname)
        with open(split_file_path, "rb") as f:
            nl = 0
            for line in f:
                if(nl>6000):
                    break
                nl += 1
                dax.append(line)
                day.append(int(fname[:-4]))
    datalen = len(dax)
    train_len = int(datalen*0.8)
    day = to_categorical(day, nb_classes=None)
    tempper = np.random.permutation(datalen)
    trx = np.array([dax[i] for i in tempper[:train_len]])
    try1 = np.array([day[i] for i in tempper[:train_len]])
    tex = np.array([dax[i] for i in tempper[train_len:]])
    tey = np.array([day[i] for i in tempper[train_len:]])
    return ((trx, try1),(tex, tey))

def nsh_tra(maxlen=400,
            max_features = 50000,
            embedding_dims = 50,
            nb_filter = 250,
            batch_size = 32,
            filter_length = [3,4,5],
            hidden_dims = 250,
            nb_epoch = 2):
    (xtr, y_train), (xte, y_test) = get_data("../split_weibo")
    token = Tokenizer(nb_words=max_features, filters=base_filter(),
            lower=True, split=" ")
    token.fit_on_texts(xtr)
    cPickle.dump(token, open("tokenfile", "wb"))
    # make up zero if it's not long enough, cut off if it's too long
    xtr = token.texts_to_sequences(xtr)
    xte = token.texts_to_sequences(xte)
    xtr = sequence.pad_sequences(xtr, maxlen=maxlen)
    xte = sequence.pad_sequences(xte, maxlen=maxlen)
    model = Sequential()
    minput = Input(shape=(maxlen, ), name='minput')
    embedding = Embedding(max_features,
        embedding_dims,
        input_length=maxlen,
        dropout=0.2)(minput)
    convs = []
    for i in filter_length:
        conv = Convolution1D(nb_filter=nb_filter,
                    filter_length=i,
                    border_mode='valid',
                    activation='relu',
                    subsample_length=1)(embedding)
        pool_layer = MaxPooling1D()(conv)
        flatten = Flatten()(pool_layer)
        convs.append(flatten)
    out = Merge(mode='concat', name="merge_name")(convs) 
    # add a vanilla hidden layer:
    dense1 = Dense(hidden_dims)(out)
    dropout1 = Dropout(0.2)(dense1)
    activation1 = Activation('relu')(dropout1)
    # project onto a single unit output layer, and squash it with a sigmoid:
    dense2 = Dense(15)(activation1)
    activation2 = Activation('softmax')(dense2)
    model = Model(input=minput, output=activation2)
    model.compile(loss='categorical_crossentropy',
                    optimizer='adam',
                    metrics=['accuracy'])
    plot(model, to_file='model.png', show_shapes=True)
    model.fit(xtr, y_train,
        batch_size=batch_size,
        nb_epoch=nb_epoch,
        validation_data=(xte, y_test))
    json_string = model.to_json()
    fs = open("weibo_model.json", "w")
    fs.write(json_string)
    fs.close()
    model.save_weights('weibo_weights.h5')
    return model

def nsh_pre(filepath ='weibo_model.json', maxlen=400):
    fs = open("weibo_model.json", "r")
    json_string = fs.read()
    fs.close()
    model = model_from_json(json_string)
    model.load_weights('weibo_weights.h5')
    token = cPickle.load(open("tokenfile", 'rb'))
    title = draw_data()
    title_item = title.get_title_data('2020-04-22', '2020-4-28', 0)
    id2text = []
    for ti in title_item:
        id2text.append([[i['_id']], list(jieba.cut(ti['title_text'])), [ti['title_content']]])
    arrayid2text = np.array(id2text)
    predictData = sequence.pad_sequences(token.texts_to_sequences(arrayid2text[:, 1]), maxlen=maxlen)
    result = model.predict(predictData)
    result_dict = dict()
    for i in range(id2text):
        print(id2text[i][2] + str(result[i]))
        result_dict[id2text[i][0]] = result[i]
    np.savez("classify.dict", result_dict)

if __name__ == "__main__":
    nsh_tra()
    # predict()
