
import datetime
import numpy as np
import matplotlib.pyplot as plt
import logging
from matplotlib import pyplot as plt

news_cly = {}
dict_id_pred = np.load("dict_id_pred.npz")['arr_0'][()]
train_day15 = []

def fitFunc(position):
    sum = 0
    for i in train_day15:
        if i in dict_id_pred:
            new_temp = news_cly[i]
            pred_new = dict_id_pred[i][0] + new_temp*position*new_temp.T
            sum +=  (dict_id_pred[i][1]-pred_new)^2
    return sum

class bird:
    def __init__(self, speed, position, fit, lBestPosition, lBestFit):
        self.speed = speed
        self.position = position
        self.fit = fit
        self.lBestFit = lBestPosition
        self.lBestPosition = lPestFit

import random

class PSO:
    def __init__(self, fitFunc, birdNum, w, c1, c2, solutionSpace):
        self.fitFunc = fitFunc
        self.w = w
        self.c1 = c1
        self.c2 = c2
        self.birds, self.best = self.initbirds(birdNum, solutionSpace)

    def initbirds(self, size, solutionSpace):
        birds = []
        for i in range(size):
            position = random.uniform(solutionSpace[0], solutionSpace[1])
            speed = 0
            fit = self.fitFunc(position)
            birds.append(bird(speed, position, fit, position, fit))
        best = birds[0]
        for bird in birds:
            if bird.fit < best.fit:
                best = bird
        return birds,best

    def updateBirds(self):
        for bird in self.birds:     
            bird.speed = self.w * bird.speed + self.c1 * random.random() * (bird.lBestPosition - bird.position) + self.c2 * random.random() * (self.best.position - bird.position)
            bird.position = bird.position + bird.speed   
            bird.fit = self.fitFunc(bird.position)
            if bird.fit < bird.lBestFit:
                bird.lBestFit = bird.fit
                bird.lBestPosition = bird.position

    def solve(self, maxIter):    
        for i in range(maxIter):
            self.updateBirds()
            for bird in self.birds:
                if bird.fit > self.best.fit:
                    self.best = bird
