
import datetime
import numpy as np
import matplotlib.pyplot as plt
import logging
from matplotlib import pyplot as plt
from sklearn.ensemble import RandomForestRegressor
from sklearn.externals import joblib
from sklearn.ensemble import AdaBoostRegressor
from sklearn.tree import DecisionTreeRegressor
from sklearn.ensemble import GradientBoostingRegressor
from sklearn import linear_model
from sklearn.metrics import explained_variance_score
from sklearn.metrics import mean_squared_error
from sklearn import linear_model
logging.basicConfig(format='%(asctime)s : %(levelname)s : %(message)s', level=logging.INFO)


def mape(p, t):
    return np.mean(abs(p-t)/t)*100


def regression():

    each_item = np.load("SHitem.npz")['arr_0'][()]
    xda = []
    yda = []
    save_id = each_item.keys();
    for i in save_id:
        if len(each_item[i]) == 4:
            xda.append(each_item[i][0:-1])
            yda.append(each_item[i][-1])
    n_sample = len(xda)
    sidx = np.random.permutation(n_sample)
    n_train = int(np.round(n_sample * 0.3))
    texset = np.log10(np.array([xda[s] for s in sidx[:n_train]])+1)
    teyset = np.array([yda[s] for s in sidx[:n_train]])
    test_id = [save_id[s] for s in sidx[:n_train]]
    trxset = np.log10(np.array([xda[s] for s in sidx])+1)
    tryset = np.log10(np.array([yda[s] for s in sidx]))
    train_id = [save_id[s] for s in sidx]
    rg = linear_model.LinearRegression()
    rg.fit(trxset, tryset)
    prey = np.power(10, rg.predict(texset))
    trypre = rg.predict(trxset)
    evs = explained_variance_score(teyset, prey)
    rmse = np.sqrt(mean_squared_error(teyset, prey))
    logging.info("rmse:"+str(rmse)+" evs:"+str(evs))
    logging.info("mape:"+str(mape(prey, teyset))+"%")
    draw_same(teyset, prey)
    dict_id_pred = dict()
    for i in range(len(train_id)):
        dict_id_pred[train_id[i]] = [trypre[i], tryset[i]]
    for i in range(len(test_id)):
        dict_id_pred[test_id[i]] = [prey[i], teyset[i]]
    np.savez("SH_pred", dict_id_pred)
    logging.info(u", done")

def draw_same(y_true, y_pred):
    plt.plot(y_true, y_pred, 'r.')
    plt.plot([0, 50000], [0, 50000], 'b-')
    plt.show()

if __name__ == "__main__":
    regression()
